const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Gemeos_digitaisDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const gemeos_digitais = await db.gemeos_digitais.create(
      {
        id: data.id || undefined,

        tipo: data.tipo || null,
        arquivo_url: data.arquivo_url || null,
        descricao: data.descricao || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await gemeos_digitais.setInspecao(data.inspecao || null, {
      transaction,
    });

    await gemeos_digitais.setClientes(data.clientes || null, {
      transaction,
    });

    return gemeos_digitais;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const gemeos_digitaisData = data.map((item, index) => ({
      id: item.id || undefined,

      tipo: item.tipo || null,
      arquivo_url: item.arquivo_url || null,
      descricao: item.descricao || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const gemeos_digitais = await db.gemeos_digitais.bulkCreate(
      gemeos_digitaisData,
      { transaction },
    );

    // For each item created, replace relation files

    return gemeos_digitais;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const gemeos_digitais = await db.gemeos_digitais.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.tipo !== undefined) updatePayload.tipo = data.tipo;

    if (data.arquivo_url !== undefined)
      updatePayload.arquivo_url = data.arquivo_url;

    if (data.descricao !== undefined) updatePayload.descricao = data.descricao;

    updatePayload.updatedById = currentUser.id;

    await gemeos_digitais.update(updatePayload, { transaction });

    if (data.inspecao !== undefined) {
      await gemeos_digitais.setInspecao(
        data.inspecao,

        { transaction },
      );
    }

    if (data.clientes !== undefined) {
      await gemeos_digitais.setClientes(
        data.clientes,

        { transaction },
      );
    }

    return gemeos_digitais;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const gemeos_digitais = await db.gemeos_digitais.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of gemeos_digitais) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of gemeos_digitais) {
        await record.destroy({ transaction });
      }
    });

    return gemeos_digitais;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const gemeos_digitais = await db.gemeos_digitais.findByPk(id, options);

    await gemeos_digitais.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await gemeos_digitais.destroy({
      transaction,
    });

    return gemeos_digitais;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const gemeos_digitais = await db.gemeos_digitais.findOne(
      { where },
      { transaction },
    );

    if (!gemeos_digitais) {
      return gemeos_digitais;
    }

    const output = gemeos_digitais.get({ plain: true });

    output.inspecao = await gemeos_digitais.getInspecao({
      transaction,
    });

    output.clientes = await gemeos_digitais.getClientes({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userClientes = (user && user.clientes?.id) || null;

    if (userClientes) {
      if (options?.currentUser?.clientesId) {
        where.clientesId = options.currentUser.clientesId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.inspecao_aerea,
        as: 'inspecao',

        where: filter.inspecao
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.inspecao
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  tipo_inspecao: {
                    [Op.or]: filter.inspecao
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.clientes,
        as: 'clientes',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.tipo) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('gemeos_digitais', 'tipo', filter.tipo),
        };
      }

      if (filter.arquivo_url) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'gemeos_digitais',
            'arquivo_url',
            filter.arquivo_url,
          ),
        };
      }

      if (filter.descricao) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'gemeos_digitais',
            'descricao',
            filter.descricao,
          ),
        };
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.clientes) {
        const listItems = filter.clientes.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          clientesId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.clientesId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.gemeos_digitais.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('gemeos_digitais', 'tipo', query),
        ],
      };
    }

    const records = await db.gemeos_digitais.findAll({
      attributes: ['id', 'tipo'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['tipo', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.tipo,
    }));
  }
};
